Bug 1471060 - (CVE-2017-1000095) CVE-2017-1000095 jenkins-plugin-script-security: Unsafe methods in the default whitelist (SECURITY-538)
CVE-2017-1000095 jenkins-plugin-script-security: Unsafe methods in the defaul...
Status: CLOSED WONTFIX
Product: Security Response
Classification: Other
Component: vulnerability (Show other bugs)
unspecified
All Linux
high Severity high
: ---
: ---
Assigned To: Red Hat Product Security
impact=important,public=20170710,repo...
: Security
Depends On: 1471061 1472032
Blocks: 1471067
  Show dependency treegraph
 
Reported: 2017-07-14 06:31 EDT by Adam Mariš
Modified: 2017-08-18 01:23 EDT (History)
12 users (show)

See Also:
Fixed In Version: jenkins-plugin-script-security 1.29.1
Doc Type: If docs needed, set a value
Doc Text:
The jenkins-plugin-script-security improperly whitelisted "DefaultGroovyMethods.putAt(Object, String, Object)" and "DefaultGroovyMethods.getAt(Object, String)" which allows attackers to bypass many restrictions and potentially trigger builds or access data they should not have access to. Exploitation of this requires the attacker to have access to the Jenkins instance, and for that Jenkins instance to be hosting other projects as well that the attacker should not have access to.
Story Points: ---
Clone Of:
Environment:
Last Closed: 2017-08-14 12:43:05 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Adam Mariš 2017-07-14 06:31:13 EDT
The default whitelist included the entries:

DefaultGroovyMethods.putAt(Object, String, Object)
DefaultGroovyMethods.getAt(Object, String)

These allowed circumventing many of the access restrictions implemented in the script sandbox by using e.g. currentBuild['rawBuild'] rather than currentBuild.rawBuild.

Additionally, the following entries allowed accessing private data that would not be accessible otherwise due to script security:

groovy.json.JsonOutput.toJson(Closure)
groovy.json.JsonOutput.toJson(Object)

External References:

https://jenkins.io/security/advisory/2017-07-10/
Comment 1 Adam Mariš 2017-07-14 06:31:36 EDT
Acknowledgments:

Name: the Jenkins project
Comment 2 Adam Mariš 2017-07-14 06:32:53 EDT
Created jenkins-script-security-plugin tracking bugs for this issue:

Affects: fedora-all [bug 1471061]
Comment 4 Trevor Jay 2017-08-14 12:43:05 EDT
Statement:

This issue affects the versions of jenkins-plugin-script-security as shipped with OpenShift Enterprise 3. However, this flaw is of low impact under the supported scenarios in OpenShift Enterprise 3. A future update may address this issue.

Note You need to log in before you can comment on or make changes to this bug.